'use strict';

var _ = require('lodash'),
		EventEmitter = require('events');

class QuerySorting extends EventEmitter {
	constructor() {
		super();
		this._sorting = [];
	}

	sort(name, direction) {
		if(arguments.length === 1) {
			direction = this.directions.ASC;
		}

		var sorting = {
			name: name,
			direction: direction
		};

		this.addSorting(sorting);

		return this;
	}

	hasSorting(sortingName) {
		return this._sorting.some(function (sorting) {
			return sorting.name === sortingName;
		});
	}

	addSorting(sorting) {
		if(!this.hasSorting(sorting.name)) {
			this._sorting.push(sorting);
		}

		return this;
	}

	reset() {
		this._sorting = [];

		return this;
	}

	toJSON() {
		return this._sorting.slice();
	}
}

_.extend(QuerySorting.prototype, {
	directions: {
		ASC: 'asc',
		DESC: 'desc'
	}
});

module.exports = QuerySorting;
