'use strict';

var _ = require('lodash'),
    Promise = require('bluebird'),
    DataProvider = require('../src/DataProvider');

class MockDataProvider extends DataProvider {
  constructor(fakeData) {
  	super();

    if(!fakeData) {
    	this.fakeData = [];
    	for(var i = 0; i < 10; i++) {
    		this.fakeData.push(i);
    	}
    } else {
      this.fakeData = fakeData;
    }
  }

	find() {
		var data = this.fakeData;

		return new Promise(function (resolve, reject) {
			resolve({data: data});
		});
	}

	findOne(name, id) {
		var data = this.fakeData;

		return new Promise(function (resolve) {
			if(_.isNumber(id)) {
        resolve(data[id]);
      }
      resolve(data[_.random(0, data.length - 1)]);
		});
	}

  save() {
    return new Promise(function(resolve) {

    });
  }

  remove () {
    return new Promise(function(resolve) {

    });
  }

  removeOne() {
    return new Promise(function(resolve, reject) {

    });
  }

  saveOne() {
    return new Promise(function(resolve) {

    });
  }
}

module.exports = MockDataProvider;
